/**
 * Export items model
 */
import { IDropDownItemModel, ICodeBlockLanguageModel, IListDropDownModel, EmojiIconsSet } from '../common/interface';
/**
 * Background color options for text formatting.
 */
export declare const backgroundColor: {
    [key: string]: string[];
};
/**
 * Font color options for text formatting.
 */
export declare const fontColor: {
    [key: string]: string[];
};
/**
 * Font family options for rich text editor.
 */
export declare const fontFamily: IDropDownItemModel[];
/**
 * Font size options for text formatting.
 */
export declare const fontSize: IDropDownItemModel[];
/**
 * Formatting options for rich text elements.
 */
export declare const formatItems: IDropDownItemModel[];
/**
 * Predefined toolbar items for the rich text editor.
 */
export declare const predefinedItems: string[];
/**
 * Table style options for text tables.
 */
export declare const TableStyleItems: IDropDownItemModel[];
/**
 * Number format list for ordered lists.
 */
export declare const numberFormatList: IListDropDownModel[];
/**
 * Bullet format list for unordered lists.
 */
export declare const bulletFormatList: IListDropDownModel[];
/**
 * List of code block languages supported by the editor.
 */
export declare const codeBlockList: ICodeBlockLanguageModel[];
export declare const defaultEmojiIcons: EmojiIconsSet[];
