import { IRichTextEditor, IRenderer } from '../base/interface';
import { IColorPickerRenderArgs } from '../../common/interface';
import { ServiceLocator } from '../services/service-locator';
import { RendererFactory } from '../services/renderer-factory';
/**
 * `Color Picker` module is used to handle ColorPicker actions.
 */
export declare class ColorPickerInput {
    private fontColorPicker;
    private backgroundColorPicker;
    protected parent: IRichTextEditor;
    protected locator: ServiceLocator;
    protected toolbarRenderer: IRenderer;
    protected renderFactory: RendererFactory;
    private tools;
    constructor(parent?: IRichTextEditor, serviceLocator?: ServiceLocator);
    private initializeInstance;
    /**
     * renderColorPickerInput method
     *
     * @param {IColorPickerRenderArgs} args - specify the arguments.
     * @returns {void}
     * @hidden

     */
    renderColorPickerInput(args: IColorPickerRenderArgs): void;
    destroy(): void;
    /**
     * destroyColorPicker method
     *
     * @returns {void}
     * @hidden

     */
    destroyColorPicker(): void;
    private setRtl;
    private setCssClass;
    private updateCss;
    protected addEventListener(): void;
    private showColorPicker;
    private onPropertyChanged;
    protected removeEventListener(): void;
}
