import { IRichTextEditor } from '../base/interface';
import { ServiceLocator } from '../services/service-locator';
/**
 * PasteCleanup module called when pasting content in RichTextEditor
 */
export declare class PasteCleanup {
    private parent;
    private pasteObj;
    private renderFactory;
    private locator;
    private contentModule;
    private i10n;
    private saveSelection;
    private nodeSelectionObj;
    private dialogRenderObj;
    private popupObj;
    private uploadObj;
    private dialogObj;
    private keepRadioButton;
    private cleanRadioButton;
    private plainTextRadioButton;
    private isNotFromHtml;
    private containsHtml;
    private cropImageData;
    private fireFoxUploadTime;
    private refreshPopupTime;
    private popupCloseTime;
    private failureTime;
    private plainTextContent;
    private isDestroyed;
    constructor(parent?: IRichTextEditor, serviceLocator?: ServiceLocator);
    private addEventListener;
    private destroy;
    private removeEventListener;
    private bindOnEnd;
    private getPasteCleanupModel;
    private updatePasteCleanupProperty;
    /**
     * Handles the paste cleanup operation when content is pasted into the editor
     *
     * @param {NotifyArgs} e - The notification arguments containing event data
     * @returns {void}
     */
    private pasteClean;
    private processHtmlPaste;
    private handleEmptyHtmlValue;
    private isInvalidImageType;
    private processPasteWithImage;
    private handleNonEmptyHtmlValue;
    private prepareAndInsertContent;
    private processUnsupportedImages;
    private handlePasteBasedOnSettings;
    private imgUploading;
    private processImagesWithSaveUrl;
    private cleanupImageClasses;
    private toolbarEnableDisable;
    private uploadMethod;
    private createPopupObject;
    private configurePopupStyles;
    private schedulePopupRefresh;
    private createUploader;
    private handleUploading;
    private handleBeforeUpload;
    private handleFailure;
    private handleCanceling;
    private handleRemoving;
    private initializeUpload;
    private hideFileSelectWrapper;
    private uploadFailure;
    private cleanupPopup;
    private cleanupUploader;
    private popupClose;
    private prepareEventArgs;
    private handleUploadStatus;
    private handleSuccessfulUpload;
    private updateImageSource;
    private updateDetachedImages;
    private handleImageRemoval;
    private scheduleCleanup;
    private resetImageOpacity;
    private resetDetachedImageOpacity;
    private refreshPopup;
    private calculateImagePosition;
    private positionPopupAtTop;
    private positionPopupAtImage;
    private imageFormatting;
    private radioRender;
    private selectFormatting;
    private pasteDialog;
    private getDialogModel;
    private getOkButton;
    private getCancelButton;
    private closeDialog;
    private getDialogContent;
    private updateCss;
    private setCssClass;
    private destroyDialog;
    private docClick;
    private formatting;
    private handlePastedImagesAndEvents;
    private execPasteCommand;
    private getCropImageData;
    private plainFormatting;
    /**
     * For internal use only - Get the module name.
     *
     * @returns {void}
     * @hidden
     */
    private getModuleName;
}
